package edu.mermet.tp8.fenetres;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import edu.mermet.tp8.Application;
import edu.mermet.tp8.preferences.Preference;

/**
 *
 * @author brunomermet
 */
public class FenetreConversion extends AbstractFenetreInterne {

    private JTextField champCelsius;
    private JTextField champFarenheit;
    private JButton boutonConvertir;
    private JButton btnAideCelsius;
    private JButton btnAideFarenheit;
    private Action actionConvertir;
    private boolean celsiusAFocus;

    public FenetreConversion(Application appli, Action action) {
        super(appli, action, "Conversion celsius/Farenheit");
        setTitle("Conversion Celsius/Farenheit");
        this.setSize(new Dimension(100,50));
        this.setLayout(new GridLayout(3,1));
        
        JPanel ligneCelsius = new JPanel();
        ligneCelsius.setLayout(new FlowLayout(FlowLayout.TRAILING));
        JLabel labCelsius = new JLabel("Celsius :");
        champCelsius = new JTextField(15);
        champCelsius.setToolTipText("Valeur en degré Celsius");        
        labCelsius.setLabelFor(champCelsius);

       
        btnAideCelsius = new JButton(new ImageIcon("./src/main/resources/images/aide.png"));
        btnAideCelsius.setPreferredSize(new Dimension(20, 20));
        btnAideCelsius.addMouseListener(new ActionAide());


        ligneCelsius.add(labCelsius);
        ligneCelsius.add(champCelsius);
        ligneCelsius.add(btnAideCelsius);

        this.add(ligneCelsius);
        celsiusAFocus = true;
        champCelsius.addFocusListener(new EcouteurFocus(true));
        champCelsius.addMouseListener(new ActionAide());

        JPanel ligneFarenheit = new JPanel();
        ligneFarenheit.setLayout(new FlowLayout(FlowLayout.TRAILING));

        JLabel labFarenheit = new JLabel("Farenheit :");
        champFarenheit = new JTextField(15);
        champFarenheit.setToolTipText("Valeur en degré Farenheit");        
        labFarenheit.setLabelFor(champFarenheit);

        btnAideFarenheit = new JButton(new ImageIcon("./src/main/resources/images/aide.png"));
        btnAideFarenheit.setPreferredSize(new Dimension(20, 20));
        btnAideFarenheit.addMouseListener(new ActionAide());
        ligneFarenheit.add(labFarenheit);
        ligneFarenheit.add(champFarenheit);
        ligneFarenheit.add(btnAideFarenheit);
        this.add(ligneFarenheit);
        champFarenheit.addFocusListener(new EcouteurFocus(false));
        champFarenheit.addMouseListener(new ActionAide());

        JPanel ligneValider = new JPanel();
        ligneValider.setLayout(new FlowLayout(FlowLayout.CENTER));
        actionConvertir = new ActionConvertir();
        boutonConvertir = new JButton(actionConvertir);
        ligneValider.add(boutonConvertir);
        this.add(ligneValider);
        pack();
        getRootPane().setDefaultButton(boutonConvertir);
    }

    private AbstractFenetreInterne getFrame()
    {
        return this;
    }

    private class EcouteurFocus implements FocusListener {
        private boolean aStocker;

        public EcouteurFocus(boolean b) {
            aStocker = b;
        }

        @Override
        public void focusGained(FocusEvent fe) {
            celsiusAFocus = aStocker;
        }

        @Override
        public void focusLost(FocusEvent fe) {
            return;
        }
    }
    private class ActionAide implements MouseListener 
    {

        @Override
        public void mouseClicked(MouseEvent e) {
            if ((e.getButton() == MouseEvent.BUTTON3 && e.getSource() == champFarenheit) || e.getSource() == btnAideFarenheit)  
            {
                JOptionPane.showMessageDialog(getFrame(),"Valeur en degré Farenheit");
            }
            
            if ((e.getButton() == MouseEvent.BUTTON3 && e.getSource() == champCelsius) || e.getSource() == btnAideCelsius)  
            {
                JOptionPane.showMessageDialog(getFrame(),"Valeur en degré Celsius");
            }
           
        }

        @Override
        public void mousePressed(MouseEvent e) {
            // TODO Auto-generated method stub
            
        }

        @Override
        public void mouseReleased(MouseEvent e) {
            // TODO Auto-generated method stub
            
        }

        @Override
        public void mouseEntered(MouseEvent e) {

        }

        @Override
        public void mouseExited(MouseEvent e) {
                         
        }


    }

    private class ActionConvertir extends AbstractAction {

        public ActionConvertir() {
            super("Convertir");
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
            Preference preference = Preference.getPreference();
            double competence = Double.parseDouble(preference.getProperty("Compétence"));
            
            double tempCelsius = 0;
            double tempFarenheit = 0;
            if (celsiusAFocus) {
                try {
                    tempCelsius = Double.parseDouble(champCelsius.getText());
                tempFarenheit = 9./5*tempCelsius+32;
                champFarenheit.setText(""+tempFarenheit);  
                competence+= 0.4;
                preference.setProperty("Compétence",competence + "");
                }
                catch (NumberFormatException nfe) {
                    champFarenheit.setText("Erreur de format");
                }
                }
            else {
                try {
                    tempFarenheit = Double.parseDouble(champFarenheit.getText());
                    tempCelsius = (tempFarenheit - 32) *5./9;
                    champCelsius.setText(""+tempCelsius);
                    competence+= 0.4;
                    preference.setProperty("Compétence",competence + "");
                }
                catch (NumberFormatException nfe) {
                    champCelsius.setText("Erreur de format");
                }
                
            }
        }
    }

}
