package edu.mermet.tp8.fenetres;

import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JDialog;

import java.awt.FlowLayout;
import java.awt.BorderLayout;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.ResourceBundle;

import javax.swing.JEditorPane;
import java.awt.Dimension;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import java.util.stream.Collectors;


import edu.mermet.tp8.preferences.Preference;


public class FenetreSuggestion extends  JDialog 
 {

	private JEditorPane editorPane;
	private JButton btnFermer; 
	private JButton btnPlusAfficher;
	private Preference preference;
	private String suggRetirer;


	public FenetreSuggestion()
	{
		preference = Preference.getPreference();

		JPanel panelSuggestion = new JPanel();
		JPanel panelButton = new JPanel();
		suggRetirer = null;
		panelButton.setLayout( new FlowLayout(FlowLayout.RIGHT));

		setLayout(new BorderLayout());

		editorPane = new JEditorPane();
		editorPane.setPreferredSize(new Dimension(500,200));
		editorPane.setText(getSugggestion());
		panelSuggestion.add(editorPane);

		btnFermer = new JButton("Fermer");
		btnPlusAfficher = new JButton("Ne plus afficher");
		btnFermer.addActionListener(new ActionButton());
		btnPlusAfficher.addActionListener(new ActionButton());

		panelButton.add(btnFermer);
		panelButton.add(btnPlusAfficher);

		this.add(panelSuggestion);
		this.add(panelButton,"South");

		this.pack();
		this.setVisible(true);

	}

	private String getSugggestion()
	{
		ResourceBundle rbSuggestion = ResourceBundle.getBundle("suggestions.sugg");

		Enumeration<String> enumSuggestion = rbSuggestion.getKeys();   
		ArrayList<String> texteSuggestion = new ArrayList<>();

		Enumeration<String> enumName = preference.propertyNames();
		ArrayList<String> nameSuggestion = new ArrayList<>();

		while(enumSuggestion.hasMoreElements())
		{
			texteSuggestion.add(enumSuggestion.nextElement());
		}

		while(enumName.hasMoreElements())
		{
			nameSuggestion.add(enumName.nextElement());
		}

		List<String> sortedText = texteSuggestion.stream().sorted().collect(Collectors.toList());

		sortedText = gererCompetence(sortedText);

		for (int i = 0; i < nameSuggestion.size(); i++) 
		{
			for (int j = 0; j <sortedText.size(); j++) 
			{
				if (sortedText.get(j).equals(nameSuggestion.get(i))) 
				{
					sortedText.remove(j);
				}
			}
		}
		
		if(!sortedText.isEmpty())
		{
			String[] tab = new String[sortedText.size()];
			tab = sortedText.toArray(tab);
			int nombreAlea = (int) (Math.random() *  tab.length - 1);
			suggRetirer = tab[nombreAlea];
			return rbSuggestion.getString(tab[nombreAlea]);
		}
		return "Vous ne voulez plus afficher de suggestion";
		
	}

	private List<String> gererCompetence(List<String> TextSuggestion)
	{
		Preference preference =  Preference.getPreference();
		double competence = Double.parseDouble(preference.getProperty("Compétence"));

		if (competence<2) 
			return TextSuggestion.subList( 0, 6);
		
		if (competence>=2 && competence<4) 
		
			return TextSuggestion.subList( 0, 7);
		

		if (competence>=4 && competence<8) 
		{
			return TextSuggestion.subList( 0, 9);
		}
		return TextSuggestion;

	}

	private void setVisibleFalse()
	{
		this.setVisible(false);
	}

	class ActionButton implements ActionListener 
	{
		public void actionPerformed(ActionEvent e) 
		{
			if(e.getSource() == btnFermer)
			{
				setVisibleFalse();
			}

			if(e.getSource() == btnPlusAfficher)
			{
				if(suggRetirer !=null)
					preference.setProperty(suggRetirer, "Caché");
					
				setVisibleFalse();
			}
		}
	
	}
	
}
